## mingw-w64-avr-gcc-15.1.0-1.src.tar.zst

=== libcody/CMakeLists.txt ===
# Top Level CMake file for libcody.

cmake_minimum_required(VERSION 3.4.3)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "No build type selected, default to MinSizeRel")
  set(CMAKE_BUILD_TYPE MinSizeRel)
  set(LIBCODY_ENABLE_ASSERTIONS 1)
endif()
string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)

set(cmake_3_2_USES_TERMINAL USES_TERMINAL)

if( CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR AND NOT MSVC_IDE)
  message(FATAL_ERROR "In-source builds are not allowed. ")
endif()

# message(STATUS "SRC ${CMAKE_SOURCE_DIR} CSRC : ${CMAKE_CURRENT_SOURCE_DIR} ")

# Add path for custom modules
set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

# If we are building stand-alone, set up the names and versions.
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR
   OR LIBCODY_STANDALONE_BUILD)

  project(libcody CXX)

  set(PACKAGE_NAME codylib)
  set(LIBCODY_VERSION_MAJOR 0)
  set(LIBCODY_VERSION_MINOR 0)
  set(LIBCODY_VERSION_PATCH 1)
  set(LIBCODY_VERSION_SUFFIX git)
  set(LIBCODY_VERSION "${LIBCODY_VERSION_MAJOR}.${LIBCODY_VERSION_MINOR}.${LIBCODY_VERSION_PATCH}")
  set(PACKAGE_VERSION "${LIBCODY_VERSION}-${LIBCODY_VERSION_SUFFIX}")
  set(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
  set(PACKAGE_URL "https://github.com/urnathan/libcody")
  set(PACKAGE_BUGREPORT "https://github.com/urnathan/libcody/issues")

  set (GIT_REV "git" "-C" "${CMAKE_CURRENT_SOURCE_DIR}" "rev-parse" "--short=12" "HEAD")
  execute_process(
      COMMAND ${GIT_REV}
      RESULT_VARIABLE HAD_ERROR
      OUTPUT_VARIABLE CODY_REVISION
    )
  if (NOT HAD_ERROR)
    string(REGEX REPLACE "\n$" "" CODY_REVISION "${CODY_REVISION}")
    set (GIT_CHANGES "git" "-C" "${CMAKE_CURRENT_SOURCE_DIR}" "diff-index" "--quiet" "HEAD" "--")
    execute_process(
      COMMAND ${GIT_CHANGES}
      RESULT_VARIABLE MOD_ERROR
      OUTPUT_VARIABLE MOD_OUTPUT
    )
    if (MOD_ERROR)
      set (CODY_REVISION "${CODY_REVISION}-modified")
    endif ()
  else()
    set(CODY_REVISION, "unknown")
  endif ()
  set(LIBCODY_STANDALONE YES)
else()
  set(LIBCODY_STANDALONE NO)
endif()

# We are using C++11
set (CMAKE_CXX_STANDARD 11)

message(STATUS "git revision ${CODY_REVISION} ")
option(CODY_CHECKING "Enable checking" ON)
# Address github issue #10
option(CODY_WITHEXCEPTIONS "Enable exceptions" OFF)

if (LIBCODY_STANDALONE)
  include(CTest)
endif()

include(libcody-config-ix)

add_definitions(
 -DPACKAGE_URL="${PACKAGE_URL}"
 -DBUGURL="${PACKAGE_BUGREPORT}"
 -DSRCDIR="${CMAKE_CURRENT_SOURCE_DIR}"
 -DPACKAGE_NAME="${PACKAGE_NAME}"
 -DPACKAGE_STRING="${PACKAGE_STRING}"
 -DPACKAGE_VERSION="${LIBCODY_VERSION}"
 -DREVISION="${CODY_REVISION}"
 )
if (CODY_CHECKING)
  add_definitions(-DNMS_CHECKING=1)
else()
  add_definitions(-DNMS_CHECKING=0)
endif()

set(LIBCODY_SOURCES
  buffer.cc
  client.cc
  fatal.cc
  netclient.cc
  netserver.cc
  resolver.cc
  packet.cc
  server.cc)

if(LIBCODY_STANDALONE)
  add_library(cody STATIC ${LIBCODY_SOURCES})
else()
  message(STATUS "Configured for in-tree build of libcody as LLVMcody")
  add_llvm_component_library(LLVMcody ${LIBCODY_SOURCES})
endif()

if (LIBCODY_STANDALONE)

  set_target_properties(cody PROPERTIES PUBLIC_HEADER "cody.hh")
  install(TARGETS cody 
        LIBRARY DESTINATION lib
        PUBLIC_HEADER DESTINATION include
  )
endif()

=== PKGBUILD ===
# Maintainer: fauxpark <fauxpark@gmail.com>

_realname=gcc
_target=avr

pkgbase=mingw-w64-${_target}-${_realname}
pkgname=${MINGW_PACKAGE_PREFIX}-${_target}-${_realname}
pkgver=15.1.0
pkgrel=1
pkgdesc='GNU compiler collection for AVR 8-bit and 32-bit microcontrollers (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url='https://www.gnu.org/software/gcc/gcc.html'
msys2_references=(
  "cpe: cpe:/a:gnu:gcc"
)
license=('spdx:GPL-3.0-or-later')
groups=("${MINGW_PACKAGE_PREFIX}-${_target}-toolchain")
depends=("${MINGW_PACKAGE_PREFIX}-${_target}-binutils"
         "${MINGW_PACKAGE_PREFIX}-gmp"
         "${MINGW_PACKAGE_PREFIX}-isl"
         "${MINGW_PACKAGE_PREFIX}-mpc"
         "${MINGW_PACKAGE_PREFIX}-mpfr"
         "${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread-git"
         "${MINGW_PACKAGE_PREFIX}-zstd")
makedepends=("${MINGW_PACKAGE_PREFIX}-autotools" "${MINGW_PACKAGE_PREFIX}-cc")
options=(!strip)
source=(https://ftp.gnu.org/gnu/${_realname}/${_realname}-${pkgver}/${_realname}-${pkgver}.tar.xz{,.sig})
sha256sums=('e2b09ec21660f01fecffb715e0120265216943f038d0e48a9868713e54f06cea'
            'SKIP')
validpgpkeys=(F3691687D867B81B51CE07D9BBE43771487328A9  # bpiotrowski@archlinux.org
              86CFFCA918CF3AF47147588051E8B148A9999C34  # evangelos@foutrelis.com
              13975A70E63C361C73AE69EF6EEB81F8981C74C7  # richard.guenther@gmail.com
              D3A93CAD751C2AF4F8C7AD516C35B99309B5FA62) # Jakub Jelinek <jakub@redhat.com>

build() {
    mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

    if [[ ${CC} == clang ]]; then
        CFLAGS+=" -Wno-int-conversion"
    fi

    declare -a _extra_config
    if [[ ${CC} == clang ]]; then
      _extra_config+=("--disable-win32-utf8-manifest")
    fi

    ../${_realname}-${pkgver}/configure \
        --prefix=${MINGW_PREFIX} \
        --target=${_target} \
        --enable-languages=c,c++ \
        --disable-nls \
        --disable-libssp \
        --disable-shared \
        --disable-threads \
        --disable-libgomp \
        --disable-libada \
        --with-dwarf2 \
        --enable-mingw-wildcard \
        "${_extra_config[@]}"

    make
}

package() {
    cd "${srcdir}/build-${MSYSTEM}"

    make DESTDIR="$pkgdir" install

    cd "${pkgdir}"${MINGW_PREFIX}

    # strip debug symbols from libraries
    find lib -type f -name "*.a" -exec ${MINGW_PREFIX}/bin/${_target}-strip --strip-debug '{}' \;

    # info and man7 files conflict with native gcc
    rm -rf share/info share/man/man7
}
